--$Name:2048$
--$Name(ru): 2048$
--$Version:0.3$
--$Author:kerbal$
instead_version "2.4.1"

require "prefs"
require "kbd"
require "click"
require "dash" -- '--' replace :)
require "quotes"
require "xact"
require "proxymenu"
--[[
js.run('document.querySelector("#win").style["line-height"]="0.6"')
]]
global{
cm = '';
inpute = '';
grid = {};
score = 0;
record = 0;
change_marker = false;
}

function init()
cm = '';
hook_keys("left", "right", "up", "down", "w", "a", "s", "d", "q");
grid = initGrid(4,4)
randomNum(grid)
record = 0
score = 0
place("stst_Record", me())
place("stst_Score", me())
place(btn_restart, me())
change_marker = false
end

stst_Record = stat{
nam = "rd",
	disp = function()
	if score > record then record = score; end;
	return txtnb("Record: "..record);
	end,
}

stst_Score = stat{
nam = "st",
	disp = function()
	return txtnb("Score:  "..score);
	end,
}


game.btn_restart = function(s)
cm = ''
inpute = ""
grid = initGrid(4,4)
randomNum(grid)
score = 0
walk("main")
end;
btn_restart = act_menu(txtc("^-----------^I restart I^-----------^"),"btn_restart");
place(btn_restart, me())

function initGrid(m,n)
	local grid = {};
    for i=1,m do
        if not grid[i] then
            grid[i] = {}
        end
        for j=1,n do
            grid[i][j] = 0
        end
    end
    return grid
end

function printGrid(grid)
    local celllen = 8
    local gridStrLines = {}
    pn(txtnb("-------------------------------------"))
    for i,row in ipairs(grid) do
        local line = {} 
        for _,num in ipairs(row) do
            if num==0 then
                local pres = ""
                for tmp=1,celllen do
                    pres = pres .. " "
                end
                local s = string.format("%s",pres)
                table.insert(line,s)
            else
                local s = tostring(num)
                local l = string.len(s)
                local l = (celllen-l)/2
                local prel = math.floor(l)
                local sufl = math.ceil(l)
                local pres = ""
                for tmp=1,prel do
                    pres = pres .. " "
                end
                local sufs = pres
                if sufl>prel then
                    sufs = pres.. " "
                end
                local s = string.format("%s%s%s",pres,s,sufs)
                table.insert(line,s)
            end
        end
        local line = table.concat(line,"|")
        line = "|" .. line .. "|"
		pn(txtnb("|        |        |        |        |"))
		pn(txtnb(line))
		pn(txtnb("|        |        |        |        |"))
        pn(txtnb("-------------------------------------"))
    end
end

function randomGrid(grid)
    local m = #grid
    local n = #grid[1]
    for i=1,m do
        for j=1,n do
            local r = math.random(1,5)
            local num = 2^r
            grid[i][j] = num
        end
    end
end

function getRandomZeroPos(grid)
    local m = #grid
    local n = #grid[1]
    local zeros = {}
    for i=1,m do
        for j=1,n do
            if grid[i][j]==0 then
                table.insert(zeros,{i=i,j=j})
            end
        end
    end
    if #zeros>0 then
        local r = math.random(1,#zeros)
        return zeros[r].i,zeros[r].j
    end
end

function randomNum(grid)
    local i,j = getRandomZeroPos(grid)
    if i and j then
        local r = math.random()
        if r<0.9 then
            grid[i][j] = 2
        else
            grid[i][j] = 4
        end
        return i,j
    end
end

function moveLeft(grid)
    pn("==============moveLeft===============")
	local canShift = false
	local canSum = false
    local m = #grid
    local n = #grid[1]
    for i=1,m do
        local line = {}
        for j=1,n do
            if grid[i][j]~=0 then
				if j > 1 then
					if grid[i][j - 1] == 0 then
					canShift = true;
					end
				end
                table.insert(line,grid[i][j])
            end
        end
        local k=#line
        for j=1,n do
            if j<=k then
                grid[i][j] = line[j]
            else
                grid[i][j] = 0
            end
        end
        for j=1,k-1 do
            if grid[i][j]==grid[i][j+1] then
				canSum = true
				score = score + grid[i][j] + grid[i][j+1]
				grid[i][j+1] = grid[i][j] + grid[i][j+1]
                for x=j,n-1 do
                    grid[i][x] = grid[i][x+1]
                end
                grid[i][n] = 0
            end
        end
		if canShift or canSum then change_marker = true; end
    end
end

function moveRight(grid)
    pn("==============moveRight==============")
	local canShift = false
	local canSum = false
	local m = #grid
	local n = #grid[1]
    for i=1,m do
		local line = {}
		for j=n,1,-1 do
			if grid[i][j]~=0 then
				if j < n then
					if grid[i][j + 1] == 0 then
					canShift = true;
					end
				end
				table.insert(line,grid[i][j])
			end
		end
		local k = #line
		for j=n,1,-1 do
			if n-j+1<=k then
				grid[i][j] = line[n-j+1]
			else
				grid[i][j] = 0
			end
		end
		for j=n,n-k+2,-1 do
			if grid[i][j]==grid[i][j-1] then
				canSum = true
				score = score + grid[i][j] + grid[i][j-1]
				grid[i][j-1] = grid[i][j] + grid[i][j-1]
				for x=j,2,-1 do
					grid[i][x] = grid[i][x-1]
				end
				grid[i][1] = 0
			end
		end
		if canShift or canSum then change_marker = true; end
    end
end


function moveUp(grid)
    pn("===============moveUp================")
	local canShift = false
	local canSum = false
	local m = #grid
	local n = #grid[1]
    for j=1,n do
		local line = {}
		for i=1,m do
			if grid[i][j]~=0 then
				if i > 1 then
					if grid[i - 1][j] == 0 then
					canShift = true;
					end
				end
				table.insert(line,grid[i][j])
			end
		end
		local k = #line
		for i=1,m do
			if i<=k then
				grid[i][j] = line[i]
			else
				grid[i][j] = 0
			end
		end
		for i=1,k-1 do
			if grid[i][j]==grid[i+1][j] then
				canSum = true
				score = score + grid[i][j] + grid[i+1][j]
				grid[i+1][j] = grid[i][j] + grid[i+1][j]
				for x=i,m-1 do
					grid[x][j] = grid[x+1][j]
				end
				grid[m][j] = 0
			end				
		end
		if canShift or canSum then change_marker = true; end
    end
end

function moveDown(grid)
    pn("==============moveDown===============")
	local canShift = false
	local canSum = false
	local m = #grid
	local n = #grid[1]
    for j=1,n do
		local line = {}
		for i=m,1,-1 do
			if grid[i][j]~=0 then
				if i < m then
					if grid[i + 1][j] == 0 then
					canShift = true;
					end
				end
				table.insert(line,grid[i][j])
			end
		end
		local k = #line
		for i=m,1,-1 do
			if m-i+1<=k then
				grid[i][j] = line[m-i+1]
			else
				grid[i][j] = 0
			end
		end
		for i=m,m-k+2,-1 do
			if grid[i][j]==grid[i-1][j] then
				canSum = true
				score = score + grid[i][j] + grid[i-1][j]
				grid[i-1][j] = grid[i][j] + grid[i-1][j]
				for x=i,2,-1 do
					grid[x][j] = grid[x-1][j]
				end
				grid[1][j] = 0
			end
		end
 		if canShift or canSum then change_marker = true; end
   end
end

function canMove(grid)
	local m = #grid
	local n = #grid[1]
    for i=1,m do
        for j=1,n do
            if grid[i][j]==0 then
                return true
            end
            if (i<m and j<n)
            and (grid[i][j]==grid[i][j+1]
                or grid[i][j]==grid[i+1][j]) then
                return true
            end
        end
    end
    return false
end

main = room{
	nam = "2048",
	dsc = function()
    if inpute~="q" then
        if inpute=="a" or inpute=="w" or inpute=="s" or inpute=="d" then
            if inpute=="a" then
                moveLeft(grid)
            elseif inpute=="w" then
                moveUp(grid)
            elseif inpute=="s" then
                moveDown(grid)
            elseif inpute=="d" then
                moveRight(grid)
            end
			if change_marker then
				randomNum(grid)
			end
			printGrid(grid)
			change_marker = false
--			if not canMove(grid) then
--			cm = txtc("==============can`tMove==============")
--			end
		else			
			pn("===============initGrid==============")
			printGrid(grid)
        end
    end
		pn(cm)
		pn()
		pn ('<c>')
		pn("--------")
	    pn("|{act1|"..txtnb("вверх ").."}|")
		pn("--------")
	    pn("-------- --------")
	    pn("|{act2|"..txtnb("влево ").."}| |{act4|вправо}|")
	    pn("-------- --------")
	    pn("--------")
		pn("|{act3|"..txtnb(" вниз ").."}|")
		pn("--------")
		pn()
		pn ('</c>')
	end,
--	
	kbd = function(s, down, key)
	if not down then
		return
	end
	if key == 'left' or key == "a" then
		inpute = "a"
		walk("main")
	elseif key == 'right' or key == "d" then
		inpute = "d"
		walk("main")
	elseif key == 'down' or key == "s" then
		inpute = "s"
		walk("main")
	elseif key == 'up' or key == "w" then
		inpute = "w"
		walk("main")
	elseif key == 'q' then
		inpute = "q"
		walk("main")
	end
end,
--	
 obj = {
 xact('act1', code[[inpute = "w"; walk("main")]]),
 xact('act2', code[[inpute = "a"; walk("main")]]),
 xact('act3', code[[inpute = "s"; walk("main")]]),
 xact('act4', code[[inpute = "d"; walk("main")]]),
 },
}

